/*

Use mikroE Timer Calculator to generate proper timer configuration
and timer ISR.

https://www.mikroe.com/timer-calculator

*/
#include "Click_G2C_types.h"

#define __G2C_TIMER__


static void g2c_configTimer()
{
    RCC_APB1ENR.TIM2EN = 1;
    TIM2_CR1.CEN = 0;
    TIM2_PSC = 2;
    TIM2_ARR = 55999;
    NVIC_IntEnable( IVT_INT_TIM2 );
    TIM2_DIER.UIE = 1;
    TIM2_CR1.CEN = 1;
    
    RXNEIE_USART6_CR1_bit = 1;
    NVIC_IntEnable( IVT_INT_USART6 );
    
    EnableInterrupts();
}

void Timer_interrupt() iv IVT_INT_TIM2
{
    g2c_tick();
    TIM2_SR.UIF = 0;
}

void RX_ISR() iv IVT_INT_USART6 ics ICS_AUTO
{
    if (RXNE_USART6_SR_bit != 0)
    {
        uint8_t rx_dat;
        
        rx_dat = UART6_Read();
        g2c_putc( rx_dat );
    }
}